=== debian/changelog ===
kaidan (0.9.1-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:58:31 +1100

kaidan (0.9.1-3build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:41:23 +0000

kaidan (0.9.1-3) unstable; urgency=medium

  * Team upload.
  * Disable the test test_GroupChatSearchManager_GroupChatModel, as it requires
    an Internet connectivity. (Closes: #1056583)

 -- Pino Toscano <pino@debian.org>  Sat, 16 Dec 2023 14:05:45 +0100

kaidan (0.9.1-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Add missing runtime dependencies:
    qml-module-org-kde-kirigami-addons-labs-mobileform, and
    qml-module-org-kde-kquickimageeditor. (Closes: #1055880)
  * Switch Vcs-* fields back to the 'master' packaging branch.

 -- Pino Toscano <pino@debian.org>  Fri, 17 Nov 2023 09:42:00 +0100

kaidan (0.9.1-1) experimental; urgency=medium

  * Team upload.
  * New upstream release. (Closes: #1036558)
  * Switch Vcs-* fields to the 'experimental' packaging branch.
  * Update build dependencies according to the upstream build system:
    - bump cmake to 3.16
    - bump Qt packages to 5.15.0
    - switch libqxmpp-dev to libqxmppqt5-dev, and bump it to 1.5.0 (to the
      actual version with OMEMO support)
    - add kirigami-addons-dev, kquickimageeditor-dev, libkf5coreaddons-dev,
      and libkf5kio-dev
  * Bump Qt dependencies to 5.15.0
  * Drop the -DI18N=TRUE cmake parameter, as translations are built
    unconditionally now.
  * Pass -DBUILD_TESTS=TRUE to cmake to build & run the unit tests at build
    time.

 -- Pino Toscano <pino@debian.org>  Sun, 12 Nov 2023 16:12:00 +0100

kaidan (0.8.0-3) unstable; urgency=medium

  * Team upload.
  * Update standards version to 4.6.2, no changes needed.
  * Replace the transitional libzxingcore-dev build dependency with
    libzxing-dev. (Closes: #1054383)
  * Update watch file.

 -- Pino Toscano <pino@debian.org>  Sat, 11 Nov 2023 21:03:07 +0100
