=== debian/control ===
Source: kaidan
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.40.0~),
               kirigami-addons-dev (>= 0.7.0~),
               kquickimageeditor-dev,
               libgstreamer1.0-dev,
               libkf5coreaddons-dev (>= 5.67.0~),
               libkf5kio-dev (>= 5.67.0~),
               libkf5notifications-dev (>= 5.67.0~),
               libkf5qqc2desktopstyle-dev (>= 5.67.0~),
               libqxmppqt5-dev (>= 1.5.5-0.2~),
               libqt5svg5-dev (>= 5.15.0~),
               libzxing-dev,
               kirigami2-dev (>= 5.67.0~),
               pkg-kde-tools,
               qtbase5-dev (>= 5.15.0~),
               qtlocation5-dev (>= 5.15.0~),
               qtmultimedia5-dev (>= 5.15.0~),
               qtpositioning5-dev (>= 5.15.0~),
               qtquickcontrols2-5-dev (>= 5.15.0~),
               qttools5-dev (>= 5.15.0~),
Standards-Version: 4.6.2
Homepage: https://www.kaidan.im/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kaidan
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kaidan.git
Rules-Requires-Root: no

Package: kaidan
Architecture: any
Depends: qml-module-org-kde-kirigami2 (>= 5.67.0~),
         qml-module-org-kde-kirigami-addons-labs-mobileform,
         qml-module-org-kde-kquickimageeditor,
         qml-module-org-kde-qqc2desktopstyle (>= 5.67.0~),
         qml-module-qtgraphicaleffects (>= 5.15.0~),
         qml-module-qtlocation (>= 5.15.0~),
         qml-module-qtmultimedia (>= 5.15.0~),
         qml-module-qtpositioning (>= 5.15.0~),
         qml-module-qtqml (>= 5.15.0~),
         qml-module-qtquick-controls2 (>= 5.15.0~),
         qml-module-qtquick-dialogs (>= 5.15.0~),
         qml-module-qtquick-layouts (>= 5.15.0~),
         qml-module-qtquick2 (>= 5.15.0~),
         ${shlibs:Depends},
         ${misc:Depends},
Description: Simple and user-friendly Jabber/XMPP client
 Kaidan is a simple, user-friendly and modern chat client. It uses the open
 communication protocol XMPP (Jabber).
 .
 The user interface makes use of Kirigami and QtQuick, while the back-end of
 Kaidan is entirely written in C++ using Qt and the Qt-based XMPP library
 QXmpp.
