## kaidan 0.9.2

=== debian/changelog ===
kaidan (0.9.2-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Update watch file.
  * Add/update Melvin Keskin’s key in upstream keyring.
  * New upstream release (0.9.2).
  * Update build-deps and deps with the info from cmake.
  * Switch to declarative KF5 debhelper build sequence.
  * Switch to dh_qmldeps for runtime QML dependencies.
  * Add missing overrides and qml dependencies for dh_qmldeps.
  * Bump Standards-Version to 4.7.0, no change required.
  * Review copyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 07 Dec 2024 23:35:04 +0100

kaidan (0.9.1-4) unstable; urgency=medium

  [ Patrick Franz ]
  * Team upload.
  * Switch kirigami-addons-dev B-D to kirigami-addons5-dev.

 -- Patrick Franz <deltaone@debian.org>  Fri, 23 Aug 2024 18:08:20 +0200
