=== debian/control ===
Source: kaidan
Section: net
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-sequence-kf5,
               dh-sequence-qmldeps,
               extra-cmake-modules (>= 5.40.0~),
               kirigami-addons-dev (>= 0.7.0~),
               kirigami-addons5-dev (>= 0.7.0~),
               kirigami2-dev (>= 5.67.0~),
               kquickimageeditor-dev,
               libgstreamer1.0-dev,
               libkf5coreaddons-dev (>= 5.67.0~),
               libkf5kio-dev (>= 5.67.0~),
               libkf5notifications-dev (>= 5.67.0~),
               libkf5qqc2desktopstyle-dev (>= 5.67.0~),
               libqt5svg5-dev (>= 5.15.0~),
               libqxmppqt5-dev (>= 1.5.5-0.2~),
               libsqlite3-dev,
               libzxing-dev,
               perl,
               pkg-kde-tools (>= 0.18.9~),
               pkgconf,
               qml-module-qtlocation,
               qml-module-qtpositioning,
               qml-module-qtquick-dialogs,
               qtbase5-dev (>= 5.15.0~),
               qtdeclarative5-dev (>= 5.15.0~),
               qtdeclarative5-dev-tools,
               qtlocation5-dev (>= 5.15.0~),
               qtmultimedia5-dev (>= 5.15.0~),
               qtpositioning5-dev (>= 5.15.0~),
               qtquickcontrols2-5-dev (>= 5.15.0~),
               qttools5-dev (>= 5.15.0~),
Standards-Version: 4.7.0
Homepage: https://www.kaidan.im/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kaidan
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kaidan.git
Rules-Requires-Root: no

Package: kaidan
Architecture: any
Depends: ${qml5:Depends},
         ${misc:Depends},
         ${shlibs:Depends},
Description: Simple and user-friendly Jabber/XMPP client
 Kaidan is a simple, user-friendly and modern chat client. It uses the open
 communication protocol XMPP (Jabber).
 .
 The user interface makes use of Kirigami and QtQuick, while the back-end of
 Kaidan is entirely written in C++ using Qt and the Qt-based XMPP library
 QXmpp.
