=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ https://download.kde.org/unstable/@PACKAGE@/([\d.]+)/@PACKAGE@-([\d.]+)\.tar\.xz
