## kaidan 0.11.0

=== debian/changelog ===
kaidan (0.11.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (0.11.0). (Closes: #1089817, #1090237, #998674)
  * Build against Qt6, update build-deps and deps with the info from cmake.
  * Refresh patches.
  * Disable build-time tests which really don’t look ready for prime
    time.
  * Review copyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 23 Feb 2025 22:54:58 +0100
