## kaidan 0.12.0

=== debian/changelog ===
kaidan (0.12.0-2) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Add patch to fix crash on initial account login.

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 25 Mar 2025 13:20:13 +0100

kaidan (0.12.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * There is no more embedded copy of singleapp to exclude from the sources,
    so simplify the packaging:
    - drop the +dfsg suffix from the version number
    - in the watch file, drop the repacking & the +dfsg suffix
    - drop the exclusions from debian/copyright
  * Update the patches:
    - upstream_appdata-fix-ID-in-translation.patch: drop, backported from
      upstream
    - upstream_Replace-SingleApplication-with-KDSingleApplication.patch: drop,
      backported from upstream
    - tests-no-network.diff: refresh
  * Update the build dependencies according to the upstream build system:
    - bump KF packages to 6.11.0
    - bump libqxmppqt6-dev to 1.10.3
  * Concatenate all the keys in debian/upstream/signing-key.asc.
  * Small updates to debian/copyright.

 -- Pino Toscano <pino@debian.org>  Mon, 24 Mar 2025 22:51:32 +0100

kaidan (0.11.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * Backport upstream commit 21ac9c2abe73115149614c3f09ed5154371de2a6 to fix
    the <translation> tag in AppStream XML metadata; patch
    upstream_appdata-fix-ID-in-translation.patch.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Update build dependencies according to the upstream build system:
    - add qml6-module-org-kde-kquickimageeditor as QML dependency
    - drop pkg-kde-tools, used via dh-sequence-*
    - drop no more used, or not used for Debian platforms:
      kquickimageeditor-dev, libgstreamer1.0-dev, libsqlite3-dev, libssl-dev,
      libzxing-dev, perl, and pkgconf
  * Replace the embedded copy of singleapp with the usage of an external
    KDSingleApplication, as newer versions of singleapp have non-free clauses:
    (Closes: #1099531)
    - ensure to not have the non-free sources, and thus repack them:
      - add a +dfsg suffix to the version number
      - adapt the watch file for repacking and the +dfsg suffix
      - exclude the 'src/singleapp' subdirectory via debian/copyright
      - disable the GPG  signing verification, since the tarball is now repacked
    - backport part of upstream commit 516f4ddc8a57e8980affabab7237064b70ecaf81
      to use KDSingleApplication; patch
      upstream_Replace-SingleApplication-with-KDSingleApplication.patch
    - add new build dependencies needed because of the changes:
      qt6-base-private-dev, libkdsingleapplication-qt6-dev, and
      libkf6windowsystem-dev

 -- Pino Toscano <pino@debian.org>  Sun, 16 Mar 2025 11:11:44 +0100
